Loading...
Searching...
No Matches
Dune::SLListModifyIterator< T, A > Class Template Reference
Common

A mutable iterator for the SLList. More...

`#include <dune/common/sllist.hh>`

Inheritance diagram for Dune::SLListModifyIterator< T, A >:

## Public Types

using | iterator_category
using | value_type
using | difference_type
using | pointer
using | reference
typedef T | DerivedType
| The type of derived iterator.
typedef T | Value
| The type of value accessed through the iterator.
typedef T * | Pointer
| The pointer to the Value.
typedef std::size_t | DifferenceType
| The type of the difference between two positions.
typedef T & | Reference
| The type of the reference to the values accessed.

## Public Member Functions

| SLListModifyIterator (SLListIterator< T, A > beforeIterator, SLListIterator< T, A > _iterator)
| SLListModifyIterator ()
T & | dereference () const
| Dereferencing function for the iterator facade.
bool | equals (const SLListConstIterator< T, A > &other) const
| Test whether another iterator is equal.
bool | equals (const SLListIterator< T, A > &other) const
| Test whether another iterator is equal.
bool | equals (const SLListModifyIterator< T, A > &other) const
| Test whether another iterator is equal.
void | increment ()
| Increment function for the iterator facade.
void | insert (const T &v)
| Insert an element at the current position.
void | remove ()
| Delete the entry at the current position.
constexpr Reference | operator* () const
| Dereferencing operator.
constexpr Pointer | operator-> () const
constexpr DerivedType & | operator++ ()
| Preincrement operator.

## Friends

class | SLListConstIterator< T, A >
class | SLListIterator< T, A >

## Detailed Description

template<typename T, class A>
class Dune::SLListModifyIterator< T, A >

A mutable iterator for the SLList.

## Member Typedef Documentation

## DerivedType

typedef T Dune::ForwardIteratorFacade< T, T, T &, std::size_t >::DerivedType

inherited

The type of derived iterator.

The iterator has to define following functions have to be present:

// Access the value referred to.
Reference dereference() const;
// Compare for equality with iterator j
bool equals(j);
// position the iterator at the next element.
void increment()
// check for equality with other iterator
bool equals(other)
Dune::SLListModifyIterator::dereference
T & dereference() const
Dereferencing function for the iterator facade.
Definition sllist.hh:446
Dune::SLListModifyIterator::equals
bool equals(const SLListConstIterator< T, A > &other) const
Test whether another iterator is equal.
Definition sllist.hh:456
Dune::SLListModifyIterator::increment
void increment()
Increment function for the iterator facade.
Definition sllist.hh:486
Dune::ForwardIteratorFacade< SLListModifyIterator< T, A >, T, T &, std::size_t >::Reference
T & Reference
Definition iteratorfacades.hh:196

For an elaborate explanation see the STL Documentation!

## difference_type

using Dune::ForwardIteratorFacade< T, T, T &, std::size_t >::difference_type

inherited

## DifferenceType

typedef std::size_t Dune::ForwardIteratorFacade< T, T, T &, std::size_t >::DifferenceType

inherited

The type of the difference between two positions.

## iterator_category

using Dune::ForwardIteratorFacade< T, T, T &, std::size_t >::iterator_category

inherited

## Pointer

typedef T* Dune::ForwardIteratorFacade< T, T, T &, std::size_t >::Pointer

inherited

The pointer to the Value.

## pointer

using Dune::ForwardIteratorFacade< T, T, T &, std::size_t >::pointer

inherited

## Reference

typedef T & Dune::ForwardIteratorFacade< T, T, T &, std::size_t >::Reference

inherited

The type of the reference to the values accessed.

## reference

using Dune::ForwardIteratorFacade< T, T, T &, std::size_t >::reference

inherited

## Value

typedef T Dune::ForwardIteratorFacade< T, T, T &, std::size_t >::Value

inherited

The type of value accessed through the iterator.

## value_type

using Dune::ForwardIteratorFacade< T, T, T &, std::size_t >::value_type

inherited

## Member Function Documentation

## operator*()

Reference Dune::ForwardIteratorFacade< T, T, T &, std::size_t >::operator* | ( |  | ) | const

inline constexpr inherited

Dereferencing operator.

## operator++()

DerivedType & Dune::ForwardIteratorFacade< T, T, T &, std::size_t >::operator++ | ( |  | ) |

inline constexpr inherited

Preincrement operator.

## operator->()

Pointer Dune::ForwardIteratorFacade< T, T, T &, std::size_t >::operator-> | ( |  | ) | const

inline constexpr inherited

The documentation for this class was generated from the following file:

- sllist.hh